
from anuga.abstract_2d_finite_volumes.generic_boundary_conditions\
     import Boundary, File_boundary

#from swb2_domain_ext import rotate
#####

#class  zero_mass_flux_transmissive_momentum_flux_boundary(Boundary):
#    """ Boundary which operates directly on the fluxes
#        CAN BE UNSTABLE -- CAREFUL
#        Sets boundary values of h, uh, vh as in transmissive boundary, but 
#        also ensures:
#        flux[0] = 0.0,
#    """
#    def __init__(self, domain = None):
#        Boundary.__init__(self)
#
#        if domain is None:
#            msg = 'Domain must be specified for zero_mass_flux_transmissive_momentum_flux boundary'
#            raise Exception, msg
#
#        self.domain = domain
#
#    def __repr__(self):
#        return 'zero_mass_flux_transmissive_momentum_flux_boundary(%s)' %self.domain
#
#    def evaluate(self, vol_id, edge_id):
#        """Transmissive boundaries return the edge values
#        of the volume they serve.
#        """
#
#        if self.domain.get_centroid_transmissive_bc() :
#            q = self.domain.get_evolved_quantities(vol_id)
#        else:
#            q = self.domain.get_evolved_quantities(vol_id, edge = edge_id)
#        return q
#
######
#
#class  zero_mass_flux_zero_momentum_boundary(Boundary):
#    """ Boundary which operates directly on the fluxes
#        Sets boundary values of h=neighbour_h, uh=0, vh=0. 
#        and ensure that:
#        flux[0] = 0.0
#    """
#    def __init__(self, domain = None):
#        Boundary.__init__(self)
#
#        if domain is None:
#            msg = 'Domain must be specified for zero_mass_flux_zero_momentum_boundary'
#            raise Exception, msg
#
#        self.domain = domain
#
#    def __repr__(self):
#        return 'zero_mass_flux_zero_momentum_boundary(%s)' %self.domain
#
#    def evaluate(self, vol_id, edge_id):
#        """ Apply chosen values to q[1], q[2]
#        """
#
#        if self.domain.get_centroid_transmissive_bc() :
#            q = self.domain.get_evolved_quantities(vol_id)
#        else:
#            q = self.domain.get_evolved_quantities(vol_id, edge = edge_id)
#
#        normal = self.domain.normals[vol_id, 2*edge_id:2*edge_id+2]
#
#        r = rotate(q, normal, direction = 1)
#        #r[1] = -r[1]
#        tdamp=0.0
#        ndamp=0.0
#        r[1]=r[1]*ndamp
#        r[2]=r[2]*tdamp
#        q = rotate(r, normal, direction = -1)
#
#        # q[1]=0.
#        # q[2]=0.
#
#        return q
#
#
#class  zero_mass_flux_zero_n_transmissive_t_momentum_boundary(Boundary):
#    """ Boundary which operates directly on the fluxes
#        Sets boundary values of h=neighbour_h, uh=0, vh=vh 
#        and ensure that:
#        flux[0] = 0.0
#    """
#    def __init__(self, domain = None):
#        Boundary.__init__(self)
#
#        if domain is None:
#            msg = 'Domain must be specified for zero_mass_flux_zero_n_transmissive_t_momentum_boundary'
#            raise Exception, msg
#
#        self.domain = domain
#
#    def __repr__(self):
#        return 'zero_mass_flux_zero_n_transmissive_t_momentum_boundary(%s)' %self.domain
#
#    def evaluate(self, vol_id, edge_id):
#        """ Apply chosen values to q[1], q[2]
#        """
#
#        if self.domain.get_centroid_transmissive_bc() :
#            q = self.domain.get_evolved_quantities(vol_id)
#        else:
#            q = self.domain.get_evolved_quantities(vol_id, edge = edge_id)
#
#        normal = self.domain.normals[vol_id, 2*edge_id:2*edge_id+2]
#
#        r = rotate(q, normal, direction = 1)
#        #r[1] = -r[1]
#        tdamp=1.0
#        ndamp=0.0
#        r[1]=r[1]*ndamp
#        r[2]=r[2]*tdamp
#        q = rotate(r, normal, direction = -1)
#
#        # q[1]=0.
#        # q[2]=0.
#
#        return q
#
#
#class  zero_mass_flux_zero_t_transmissive_n_momentum_boundary(Boundary):
#    """ Boundary which operates directly on the fluxes
#        Sets boundary values of h=neighbour_h, uh=neighbour_uh, vh=0.
#        and ensure that:
#        flux[0] = 0.0
#    """
#    def __init__(self, domain = None):
#        Boundary.__init__(self)
#
#        if domain is None:
#            msg = 'Domain must be specified for zero_mass_flux_zero_t_transmissive_n_momentum_boundary'
#            raise Exception, msg
#
#        self.domain = domain
#
#    def __repr__(self):
#        return 'zero_mass_flux_zero_t_transmissive_n_momentum_boundary(%s)' %self.domain
#
#    def evaluate(self, vol_id, edge_id):
#        """ Apply chosen values to q[1], q[2]
#        """
#
#        if self.domain.get_centroid_transmissive_bc() :
#            q = self.domain.get_evolved_quantities(vol_id)
#        else:
#            q = self.domain.get_evolved_quantities(vol_id, edge = edge_id)
#
#        normal = self.domain.normals[vol_id, 2*edge_id:2*edge_id+2]
#
#        r = rotate(q, normal, direction = 1)
#        #r[1] = -r[1]
#        tdamp=0.0
#        ndamp=1.0
#        r[1]=r[1]*ndamp
#        r[2]=r[2]*tdamp
#        q = rotate(r, normal, direction = -1)
#
#        # q[1]=0.
#        # q[2]=0.
#
#        return q
#
#
class Characteristic_boundary(Boundary):
    """

    Example:

    def waveform(t):
        return sea_level + normalized_amplitude/cosh(t-25)**2

    Bf = Nudge_boundary(domain, waveform)

    Underlying domain must be specified when boundary is instantiated
    """

    def __init__(self, domain=None, function=None):
        """ Instantiate a
            Nudge_boundary.
            domain is the domain containing the boundary
            function is the function to apply
        """

        Boundary.__init__(self)

        if domain is None:
            msg = 'Domain must be specified for this type boundary'
            raise Exception, msg

        if function is None:
            msg = 'Function must be specified for this type boundary'
            raise Exception, msg

        self.domain = domain
        self.function = function


    def __repr__(self):
        """ Return a representation of this instance. """
        msg = 'Nudge_boundary'
        msg += '(%s)' % self.domain
        return msg


    def evaluate(self, vol_id, edge_id):
        """
        """

        q = self.domain.get_conserved_quantities(vol_id, edge = edge_id)
        bed = self.domain.quantities['elevation'].centroid_values[vol_id]
        depth=max(q[0]-bed,0.0)
        dt=self.domain.timestep

        normal = self.domain.get_normal(vol_id, edge_id)


        t = self.domain.get_time()

        if hasattr(self.function, 'time'):
            # Roll boundary over if time exceeds
            while t > self.function.time[-1]:
                msg = 'WARNING: domain time %.2f has exceeded' % t
                msg += 'time provided in '
                msg += 'Flather_boundary object.\n'
                msg += 'I will continue, reusing the object from t==0'
                log.critical(msg)
                t -= self.function.time[-1]

        value = self.function(t)
        try:
            x = float(value)
        except:
            x = float(value[0])

        ##
        ndotq = (normal[0]*q[1] + normal[1]*q[2]) # momentum perpendicular to the boundary

        if(depth==0.):
            q[0] = x
            q[1] = 0. 
            q[2] = 0. 

        else:

            # Asssume sub-critical flow. Set the values of the characteristics as
            # appropriate, depending on whether we have inflow or outflow
            tmp = (9.8/depth)**0.5
            if(ndotq>0.):
                # Only need to impose one characteristic
                # Assume zero external velocity (dangerous?)
                # FIXME: Allow external velocities to be specified in the function
                # This would be needed to use the boundary for real inflows (e.g. run_wave.py)
                # At the moment, it seems to work okay as a 'passive' outflow boundary (e.g. run_wave.py)
                # Here it attenuates the wave at the outflow a bit, but doesn't do too much damage compared
                # with the other boundary conditions
                w1 = 0. - tmp*x
                w2 = (+normal[1]*q[1] -normal[0]*q[2])/depth
                w3 = ndotq/depth + tmp*q[0]
                
            else:
                # Need to set 2 characteristics
                # Assume zero external velocity (dangerous?)
                # FIXME: Allow this to be specified with a function
                w1 = 0. - tmp*x
                w2 = 0.
                #w2 = (+normal[1]*q[1] -normal[0]*q[2])/depth
                w3 = ndotq/depth + tmp*q[0]


            q[0] = (w3-w1)/(2*tmp)
            qperp= (w3+w1)/2. *depth
            qpar=  w2*depth

            # So q[1], q[2] = qperp*(normal[0], normal[1]) + qpar*(-normal[1], normal[0])

            q[1] = qperp*normal[0] + qpar*normal[1]
            q[2] = qperp*normal[1] -qpar*normal[0]

        return q
###
def rotate(q,normal,direction=1):
    #Function for rotation -- better to mimic the shallow water one
    # FIXME: Use C version
    out=q*1.      

    if(direction==1):
        out[1] = q[1]*normal[0] + q[2]*normal[1]    
        out[2] = -q[1]*normal[1] + q[2]*normal[0]
    elif(direction==-1):
        out[1] = q[1]*normal[0] - q[2]*normal[1]    
        out[2] = +q[1]*normal[1] + q[2]*normal[0]
    else:
        print 'ERROR IN rotate'
        assert 0==1

    return out
